/* 
 * Gnome Memory Blocks
 *
 * Copyright (C) 2000 The Free Software Foundation
 *
 * Author: Vova Babin <vb@dwuj.ichf.edu.pl>
 */

/*
 *  This code is very dirty. I'll rethink it in next realise
 */

#include <gmodule.h>
#include "game-item-animation.h"
#include "sliding-frames.h"

#define V_BORDER 8
#define H_BORDER 8
#define FRAME_WIDTH sliding_frame.width
#define FRAME_HEIGHT sliding_frame.height
#define PICTURE_WIDTH (FRAME_WIDTH/2 - 2*H_BORDER)
#define PICTURE_HEIGHT (FRAME_HEIGHT - 2*V_BORDER)
#define SLIDE_STEP 8
#define ANIMATION_TIMEOUT 50

static GdkPixbuf *pixbuf = NULL;

G_MODULE_EXPORT void
g_module_unload (GModule * module)
{
  if (pixbuf)
    {
      gdk_pixbuf_unref (pixbuf);
      pixbuf = NULL;
    }
}

G_MODULE_EXPORT const gchar *
g_module_check_init (GModule * module)
{
  pixbuf = gdk_pixbuf_new_from_data ((guchar *) sliding_frame.pixel_data,
				     GDK_COLORSPACE_RGB,
				     TRUE,
				     8,
				     FRAME_WIDTH,
				     FRAME_HEIGHT,
				     4 * FRAME_WIDTH, NULL, NULL);
  if (!pixbuf)
    {
      return "failed to create tile picture";
    }
  else
    return NULL;
}

GameItemAnimation *
create_flip (GdkPixbuf * picture)
{
  GdkPixbuf *tmp, *frame_pixbuf, *pic_sized;
  GameItemAnimation *flip;
  GameItemFrame *frame;
  guint offset;

  flip = game_item_animation_new ();
  if (gdk_pixbuf_get_width (picture) != PICTURE_WIDTH ||
      gdk_pixbuf_get_height (picture) != PICTURE_HEIGHT)
    pic_sized =
      gdk_pixbuf_scale_simple (picture, PICTURE_WIDTH, PICTURE_HEIGHT,
			       GDK_INTERP_HYPER);
  else
    {
      pic_sized = picture;
      gdk_pixbuf_ref (pic_sized);
    }
  tmp = gdk_pixbuf_copy (pixbuf);
  gdk_pixbuf_composite (pic_sized,
			tmp,
			H_BORDER + FRAME_WIDTH / 2,
			V_BORDER,
			PICTURE_WIDTH,
			PICTURE_HEIGHT,
			0.0,
			(double) V_BORDER, 1.0, 1.0, GDK_INTERP_HYPER, 250);
  offset = 0;
  while (offset <= FRAME_WIDTH / 2)
    {
      frame_pixbuf = gdk_pixbuf_new (GDK_COLORSPACE_RGB,
				     TRUE, 8, FRAME_WIDTH / 2, FRAME_HEIGHT);
      gdk_pixbuf_copy_area (tmp,
			    offset, 0,
			    FRAME_WIDTH / 2,
			    FRAME_HEIGHT, frame_pixbuf, 0, 0);
      frame = game_item_frame_new (frame_pixbuf, 0, 0, ANIMATION_TIMEOUT);
      gdk_pixbuf_unref (frame_pixbuf);
      game_item_animation_append_frame (flip, frame);
      offset += SLIDE_STEP;
    }
  gdk_pixbuf_unref (tmp);
  gdk_pixbuf_unref (pic_sized);
  return flip;
}

GameItemAnimation *
create_hide (GdkPixbuf * picture)
{
  GdkPixbuf *tmp, *frame_pixbuf, *pic_sized;
  GameItemAnimation *hide;
  GameItemFrame *frame;
  guint offset;

  hide = game_item_animation_new ();
  if (gdk_pixbuf_get_width (picture) != PICTURE_WIDTH ||
      gdk_pixbuf_get_height (picture) != PICTURE_HEIGHT)
    pic_sized =
      gdk_pixbuf_scale_simple (picture, PICTURE_WIDTH, PICTURE_HEIGHT,
			       GDK_INTERP_HYPER);
  else
    {
      pic_sized = picture;
      gdk_pixbuf_ref (pic_sized);
    }
  tmp = gdk_pixbuf_copy (pixbuf);
  gdk_pixbuf_composite (pic_sized,
			tmp,
			H_BORDER + FRAME_WIDTH / 2,
			V_BORDER,
			PICTURE_WIDTH,
			PICTURE_HEIGHT,
			0.0,
			(double) V_BORDER, 1.0, 1.0, GDK_INTERP_HYPER, 250);
  offset = 0;
  while (offset < FRAME_WIDTH / 2)
    {
      frame_pixbuf = gdk_pixbuf_new (GDK_COLORSPACE_RGB,
				     TRUE,
				     8,
				     FRAME_WIDTH / 2 - offset, FRAME_HEIGHT);
      gdk_pixbuf_copy_area (tmp,
			    FRAME_WIDTH / 2 + offset, 0,
			    FRAME_WIDTH / 2 - offset,
			    FRAME_HEIGHT, frame_pixbuf, 0, 0);
      frame = game_item_frame_new (frame_pixbuf, 0, 0, ANIMATION_TIMEOUT);
      gdk_pixbuf_unref (frame_pixbuf);
      game_item_animation_append_frame (hide, frame);
      offset += SLIDE_STEP;
    }
  gdk_pixbuf_unref (tmp);
  gdk_pixbuf_unref (pic_sized);
  return hide;
}
