/*
 * Gnome Memory Blocks
 * (C) 2000 the Free Software Foundation
 *
 * Author: Vova Babin <vb@dwuj.ichf.edu.pl>
 */

#ifndef __GAME_APP_H__
#define __GAME_APP_H__

#include <gnome.h>
#include "game-clock.h"
#include "game-board.h"

#ifdef HAVE_CONFIG_H
#include "config.h"
#else
#define VERSION "current"
#define PACKAGE "gnome-memblocks"
#define GNOMELOCALEDIR ""
#endif

#define GAME_APPNAME "gnome-memblocks"
#define GAME_APPNAME_LONG "Gnome Memory Blocks"
#define GAME_CONFIG_PREFIX "/gnome-memblocks/preferences/"

#define GAME_APP_TYPE            (game_app_get_type ())
#define GAME_APP(obj)            (GTK_CHECK_CAST ((obj), GAME_APP_TYPE, GameApp))
#define GAME_APP_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), GAME_APP_TYPE, GameAppClass))
#define IS_GAME_APP(obj)         (GTK_CHECK_TYPE ((obj), GAME_APP_TYPE))
#define IS_GAME_APP_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GAME_APP_TYPE))

typedef struct _GameApp GameApp;
typedef struct _GameAppClass GameAppClass;

struct _GameApp
{
  GnomeApp app;
  GnomeAppBar *bar;
  GameClock *clock;
  GtkWidget *board;
  gboolean sound;
  gboolean demo;
  /* privat */
  GtkWidget *new_game_menu_item;
  GtkWidget *new_game_button;
  GtkWidget *demo_toggle_button;
  GtkWidget *sound_toggle_button;
};

struct _GameAppClass
{
  GnomeAppClass parent_class;
  void (*new_game) (GameApp *);
  void (*prefs) (GameApp *);
  void (*exit_game) (GameApp *);
  void (*demo_activated) (GameApp *);
  void (*sound_activated) (GameApp *);
};

GtkType game_app_get_type (void);
void game_app_set_sound (GameApp *, gboolean);
void game_app_set_demo (GameApp *, gboolean);
GtkWidget *game_app_new (void);

#endif /* __GAME_APP_H__ */
