/* 
 * Gnome Memory Blocks
 *
 * Copyright (C) 2000 The Free Software Foundation
 *
 * Author: Vova Babin <vb@dwuj.ichf.edu.pl>
 */

#ifndef __GAME_BOARD_H__
#define __GAME_BOARD_H__

#include <gtk/gtk.h>
#include "game-item.h"

#define GAME_BOARD_TYPE            (game_board_get_type ())
#define GAME_BOARD(obj)            (GTK_CHECK_CAST (obj, GAME_BOARD_TYPE, GameBoard))
#define GAME_BOARD_CLASS(klass)    (GTK_CHECK_CLASS_CAST (klass, GAME_BOARD_TYPE, GameBoardClass))
#define IS_GAME_BOARD(obj)         (GTK_CHECK_TYPE ((obj), GAME_BOARD_TYPE))
#define IS_GAME_BOARD_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GAME_BOARD_TYPE))

typedef struct _GameBoard GameBoard;
typedef struct _GameBoardClass GameBoardClass;

typedef void (*GameBoardFunc) (GameItem *, gpointer);

GtkType game_board_get_type (void);
GtkWidget *game_board_new (void);
void game_board_set_bg_from_pixmap (GameBoard *, GdkPixmap *);
void game_board_set_bg_from_pixbuf (GameBoard *, GdkPixbuf *);
void game_board_attach_item (GameBoard *, GameItem *, guint x, guint y);
void game_board_foreach_item (GameBoard *, GameBoardFunc, gpointer);
void game_board_reset_and_shufle_items (GameBoard *);

GameItem *game_board_get_random_item (GameBoard *);

#endif /* __GAME_BOARD_H__ */
