/*
 * gtk-clock: The GTK clock widget
 * (C)1998 The Free Software Foundation
 *
 * Author: Szekeres Istvn (szekeres@cyberspace.mht.bme.hu)
 */

/*
 * Slightly modified (modifications not finished yet)
 * by Svyatoslav Kondrat <valiska@lulu.ichf.edu.pl>
 * for Gnome Memory Blocks
 * 30.08.2000
 */

#ifndef __GAME_CLOCK_H__
#define __GAME_CLOCK_H__

#include <time.h>
#include <gtk/gtk.h>
#include "game-digit.h"

#define GTK_TYPE_GAME_CLOCK            (game_clock_get_type ())
#define GAME_CLOCK(obj)                (GTK_CHECK_CAST((obj), GTK_TYPE_GAME_CLOCK, GameClock))
#define GAME_CLOCK_CLASS(klass)        (GTK_CHECK_CAST_CLASS((klass), GTK_TYPE_GAME_CLOCK, GameClockClass))
#define GTK_IS_GAME_CLOCK(obj)         (GTK_CHECK_TYPE((obj), GTK_TYPE_GAME_CLOCK))
#define GTK_IS_GAME_CLOCK_CLASS(klass) (GTK_CHECK_CLASS_TYPE((klass), GTK_TYPE_GAME_CLOCK))

typedef struct _GameClock GameClock;
typedef struct _GameClockClass GameClockClass;

typedef enum
{
  GAME_CLOCK_INCREASING,
  GAME_CLOCK_DECREASING,
  GAME_CLOCK_REALTIME
}
GameClockType;

struct _GameClock
{
  GtkToolbar toolbar;
  time_t seconds;
  time_t stopped;
  struct tm *tm;
  /* privat */
  GameDigit *digits[5];
  GameDigitDirection direction;
  GameClockType type;
  gint timer_id;
  gint update_interval;
};

struct _GameClockClass
{
  GtkToolbarClass parent_class;
};

GtkType game_clock_get_type (void);
GtkWidget *game_clock_new (GameClockType);
void game_clock_set_seconds (GameClock *, time_t seconds);
void game_clock_set_update_interval (GameClock *, gint seconds);
void game_clock_start (GameClock *);
void game_clock_continue (GameClock *);
void game_clock_stop (GameClock *);
void game_clock_set_direction (GameClock *, GameDigitDirection);
GameDigitDirection game_clock_get_direction (GameClock *);

#endif /* __GAME_CLOCK_H__ */
