/*
 * Gnome Memory Blocks
 * (C) 2000 the Free Software Foundation
 *
 * Author: Vova Babin <vb@dwuj.ichf.edu.pl>
 */

#ifndef __GAME_H__
#define __GAME_H__

#include "game-app.h"

#define GAME_TYPE            (game_get_type ())
#define GAME(obj)            (GTK_CHECK_CAST (obj, GAME_TYPE, Game))
#define GAME_CLASS(klass)    (GTK_CHECK_CLASS_CAST (klass, GAME_TYPE, GameClass))
#define IS_GAME(obj)         (GTK_CHECK_TYPE ((obj), GAME_TYPE))
#define IS_GAME_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GAME_TYPE))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GameTileSet GameTileSet;

struct _Game
{
  GameApp app;
  /* core game stuff :-)) */
  GameItem *open_items[2];
  guint total_items;
  guint hidden_items;
  guint demo_timeout;
  /* preferences */
  gboolean pixmap_on_bg;
  gchar *bg_pixmap_fname;
  gchar *animation_engine;
  /* preferences GUI */
  GtkWidget *prefs_window;
};

struct _GameClass
{
  GameAppClass klass;
};

GtkType game_get_type (void);
GtkWidget *game_new (void);

#endif	/* __GAME_H__ */
